import { Construct } from 'constructs';
import { BackendOutputStorageStrategy, FunctionResources, ResourceAccessAcceptor, ResourceAccessAcceptorFactory, ResourceProvider } from '@aws-amplify/plugin-types';
import { Stack } from 'aws-cdk-lib';
import { FunctionOutput } from '@aws-amplify/backend-output-schemas';
/**
 * A base class for function constructs.
 */
export declare abstract class AmplifyFunctionBase extends Construct implements ResourceProvider<FunctionResources>, ResourceAccessAcceptorFactory {
    private readonly outputStorageStrategy;
    readonly stack: Stack;
    abstract resources: FunctionResources;
    abstract getResourceAccessAcceptor: () => ResourceAccessAcceptor;
    /**
     * Creates base function construct.
     */
    protected constructor(scope: Construct, id: string, outputStorageStrategy: BackendOutputStorageStrategy<FunctionOutput>);
    protected storeOutput: () => void;
}
//# sourceMappingURL=function_construct_base.d.ts.map